<template>
    <div :class="classList" @click="$emit('close')">
        {{ compMessage }}
    </div>
</template>

<script>
    export default {
        props: {
            type: {
                type: String,
                default: 'info'
            },
            message: {
                type: [String, Array],
                default: ''
            },
            isClosing: {
                type: Boolean,
                default: false,
            }
        },
        data() {
            return {
                show: false
            }
        },
        computed: {
            classList: function() {
                return {
                    alert: true,
                    fade: true,
                    show: this.show && !this.isClosing,
                    'alert-info': this.type === 'info',
                    'alert-danger': this.type === 'danger',
                    'alert-success': this.type === 'success',
                }
            },
            compMessage: function() {
                if (this.message instanceof String || typeof this.message === "string")
                    return this.message;

                return this.message.join(' ');
            }
        },
        mounted() {
            setTimeout(() => this.show = true, 500);
        },
        name: "Alert"
    }
</script>

<style scoped>

</style>